=== debian/changelog ===
micropython (1.12-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.0

 -- Yangfl <mmyangfl@gmail.com>  Sun, 09 Feb 2020 22:38:54 +0800

micropython (1.11-1) unstable; urgency=medium

  * Initial Release (closes: #926561)

 -- Yangfl <mmyangfl@gmail.com>  Tue, 19 Nov 2019 22:09:47 +0800
