=== debian/tests/control ===
Tests: unittest.sh
Depends: @builddeps@, micropython
