=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%micropython-$1.tar.gz%" \
   https://github.com/micropython/micropython/releases \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
